#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>
#include <assert.h>
#include <pthread.h>

void *writer_func(void *arg)
{
  int i;
  char *message = (char *) arg;

  for(i = 0; i < 10; i++) {
    printf("Hi %s! \t(I'm %x)\n", message, (int)pthread_self());
    sleep(1); 
  }
  return NULL;
}

int main(void)
{ 
  int i;
  
  void *status;
  pthread_t writer1_tid, writer2_tid;
  pthread_attr_t attributes;

  /* Pour l'instant, nous conservons les valeurs par dfaut
     en ce qui concerne les attributs des processus... */
  i = pthread_attr_init(&attributes);
  assert(i == 0);
  
  /* Cration des processus lgers */
  i = pthread_create(&writer1_tid, &attributes, writer_func, "Alice");
  assert(i == 0);
  i = pthread_create(&writer2_tid, &attributes, writer_func, "Bob");
  assert(i == 0);
 
  writer_func("Charlie");
  
  /* Rcupration de leur terminaison */
  i= pthread_join(writer1_tid, &status);
  assert(i == 0);
  i= pthread_join(writer2_tid, &status);
  assert(i == 0);
  
  return 0;
}




